VERSION 5.00
Begin VB.Form fenMere 
   AutoRedraw      =   -1  'True
   Caption         =   "Chane Vertbrale Minimale  (2004)  [Freeware par BgB_S]"
   ClientHeight    =   7005
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8325
   Icon            =   "fenMere.frx":0000
   LinkTopic       =   "fenMere"
   ScaleHeight     =   467
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   555
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.PictureBox picBoxAffichage 
      BackColor       =   &H00FFFFFF&
      ClipControls    =   0   'False
      DrawWidth       =   2
      FillStyle       =   0  'Solid
      Height          =   6975
      Left            =   0
      ScaleHeight     =   461
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   549
      TabIndex        =   0
      Top             =   0
      Width           =   8295
   End
End
Attribute VB_Name = "fenMere"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Chaine Vertbrale Minimale
'Freeware (2004)
'By Beaugrand Billet Samuel
'ScSami@Yahoo.Fr

'Toutes les explications du concept sont
'dans l'image fournie avec...

'Impose la dclaration de toutes les variables
Option Explicit

'Dclaration des variables globales
Private Const PI = 3.141592  'Constante trigonomtrique
Private varNbrPts As Integer
Private varEspaces As Integer
Private varEpaisseur As Integer
Private tblPoints() As Single  'Tableau de valeurs relles ( virgules)


Private Sub Form_Load()  'Chargement de la feuille
 'Affiche la feuille ds son chargement
 'Note : "Me" remplace le nom de la feuille.
 ' Autrement dit, c'est une instruction qui
 ' "pointe vers la feuille" quelque soit son nom.
 Me.Show  'Appel sa mthode "Afficher"
 
 '###################################################
 '###  A MODIFIER  ##################################
 '###################################################
 'Initialise quelques variables...
 varNbrPts = 40    'Le nombre de vertebres
 varEspaces = 11   'La taille des segments (vertebres)
 varEpaisseur = 1  'leur paisseur (celle des traits)
 '###################################################
 '###################################################
 
 'Appel la procdure d'initialisation de la chaine vertebrale
 Call procInitialisation
End Sub


Private Sub Form_Resize()  'Lorsque la fentre est redimensionne
 'On ajuste la PictureBox  la taille de la fentre
 With picBoxAffichage
  .Top = 0
  .Left = 0
  .Width = Me.ScaleWidth
  .Height = Me.ScaleHeight
 End With
End Sub


'Procdure d'initialisation des valeurs de
'dpart de la chaine vertbrale.
Private Sub procInitialisation()
 'Dclaration des variables locales
 Dim varPointX As Single
 Dim varPointY As Single
 Dim varPoints As Integer
 
 'Redimentionne le tableau (dynamique donc) stockant
 'les coordonnes des points (vertebres).
 'Il a deux dimentions et n'est pas carr.
 'La 1re colonne de la 2me dimension stock les X et
 'la 2me colonne stock les Y[verticale].
 ReDim tblPoints(varNbrPts, 2)
 
 varPointX = varEspaces * varNbrPts
 varPointY = varPointX
 For varPoints = 1 To varNbrPts
  tblPoints(varPoints, 1) = varPointX
  tblPoints(varPoints, 2) = varPointY
  varPointX = varPointX - varEspaces
  varPointY = varPointX
 Next varPoints
 
 'Initialise le premier affichage
 Call procAffiPoints
 
End Sub


'Se produit ds que la souris bouge sur le PictureBox
Private Sub picBoxAffichage_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
 'On dclare les variables locales
 Dim xx As Single
 Dim yy As Single
 Dim xx1 As Single
 Dim yy1 As Single
 Dim xx2 As Single
 Dim yy2 As Single
 Dim CosX As Single
 Dim SinY As Single
 Dim RayHypo As Single
 Dim varPoint As Integer
 
 'On test qu'au moins 1 bouton soit enfonc
 'sinon on quitte la procdure ce qui vite
 '1 niveau d'imbrication supplmentaire et
 'du coup, une indentation!
 If Button = 0 Then Exit Sub
 
 tblPoints(1, 1) = X  'Le 1er point (la tte) de la chaine
 tblPoints(1, 2) = Y  ' se cale sur notre souris.
 
 'Initialisation du 1er point
 xx1 = tblPoints(1, 1)
 yy1 = tblPoints(1, 2)
 'Boucle  partir du 2me point passant en revu tous les pts.
 For varPoint = 2 To varNbrPts
  'Initialisation du 2me point
  xx2 = tblPoints(varPoint, 1)
  yy2 = tblPoints(varPoint, 2)
  
  'Calcul les tailles (relatives) des segments vertebraux
  xx = xx2 - xx1
  yy = yy2 - yy1
  'Simple application du thorme de Pythagore :
  'ABS(xx|yy) nous donne la valeur absolue de la taille
  'des segments (afin qu'ils ne soient pas ngatifs).
  'SQR() fait la racine carr.
  'x^2 met X au carr (x).
  'Ce qui nous donne, outre l'hypotnuse (N.B.: nom fm.),
  'le rayon.
  RayHypo = Sqr((Abs(xx) ^ 2) + (Abs(yy) ^ 2))
  
  'On calcul manuellement (et c'est l toute l'astuce de
  ' ce prog), le cosinus et le sinus nous permettant de
  ' retrouver les valeurs en allant trs trs vite!
  CosX = xx / RayHypo
  SinY = yy / RayHypo
  'Comme pour dessiner un cercle!
  '(N.B.: que varEspaces fait ici office de rayon!!!)
  tblPoints(varPoint, 1) = xx1 + (varEspaces * CosX)
  tblPoints(varPoint, 2) = yy1 + (varEspaces * SinY)
  
  'Assigne les nouelles valeurs
  'du point 2 au nouveau point 1
  'afin de fermer la boucle.
  xx1 = tblPoints(varPoint, 1)
  yy1 = tblPoints(varPoint, 2)
 Next varPoint
 
 'Appel la procdure d'affichage de la chane vertbrale
 Call procAffiPoints
End Sub


'Dessine les vertbres sur la PictureBox consacre.
Private Sub procAffiPoints()
 'Initialise les variables locales
 Dim varPoint As Integer
 Dim xx1 As Single
 Dim yy1 As Single
 Dim xx2 As Single
 Dim yy2 As Single
 
 'Rafrachit (efface) la zone de dessin.
 '(N.B.: Vous pouvez galement tester sans
 ' en mettant la ligne suivante en commmentaire
 ' [en plaant une apostrophe tout devant]
 ' ce qui, outre vite le clignottement sur les
 ' ordis lents, un effet graphique intressant
 ' proche des spirographes.
 picBoxAffichage.Refresh
 
 'Rglage de l'paisseur des traits
 picBoxAffichage.DrawWidth = varEpaisseur
 
 'Fait une boucle afin d'afficher chaque segment
 For varPoint = 1 To (varNbrPts - 1)
  xx1 = tblPoints(varPoint, 1)
  yy1 = tblPoints(varPoint, 2)
  xx2 = tblPoints(varPoint + 1, 1)
  yy2 = tblPoints(varPoint + 1, 2)
  
  'Note : Comme pour le rafrachissement, n'hsitez pas
  ' tester les diffrents types d'affichage des vertebres!
  
  'Affichage normal (lignes)
  picBoxAffichage.Line (xx1, yy1)-(xx2, yy2), 0
  
  'Affichage par points
  'picBoxAffichage.PSet (xx1, yy1), 0: picBoxAffichage.PSet (xx2, yy2), 0
  
  'Affichage par cercles
  'picBoxAffichage.Circle (((xx1 + xx2) / 2), ((yy1 + yy2) / 2)), varEspaces, 0
 Next varPoint
End Sub

'Amliorations possibles :
'- Meilleurs accs aux options
'- Ajout d'options (couleurs, ...)
'- Ajout d'un mode de dplacement automatique alatoire
'  a champ de vision limit (10 est parfait!).
'- Meilleur dfinition des segments vertebraux et de leurs
'  rapports afin de pouvoir dplacer n'importe quel pivot.
'- Ajouter de l'elasticit (tension) aux segments.
'- Ajout de la gravit (c--d : dcalage du plan de travail)
'- Mise en 3D.
'...
'Bref, les amliorations possibles sont nombreuses. A vous
'de voir o et comment intgrer ce procd dans vos
'programmes (jeux, prog de dessin, screen saver, ...).
'Etant curieux par nature je vous serais gr de m'avertir
'si vous trouvez une application  ce concept ;-)
'En attendant, amusez-vous bien!
